import Rack, Specialists, Customizers, AttributeProviders, SheetProviders
import DataSkins, Agents, Providers, PlugIns

from zLOG import register_subsystem
register_subsystem('ZPatterns')

def initialize(context):

    PlugIns.initialize(context)
    Rack.initialize(context)
    Specialists.initialize(context)
    Customizers.initialize(context)
    AttributeProviders.initialize(context)
    SheetProviders.initialize(context)
    DataSkins.initialize(context)
    Providers.initialize(context)
    Agents.initialize(context)

    if hasattr(context,'registerHelp'):
        context.registerHelp()

# The only way to register extra permissions for a ZClass base at present
# Waaaa
__ac_permissions__ = (
    ('Delete rack-mounted objects', ()),
)

# Backward compatibility needed due to the way registerBaseClass makes
# ZClass meta-classes...

from DataSkins import _ZClass_for_DataSkin
_ZClass_for_RackMountable = _ZClass_for_DataSkin  # pre 0.4.0 compatibility

